#include "cs_thread.h"
#include "barrier.c"
struct Repositioning {
	char player; 		// T for turtle and H for hare
	int time; 		// At what time god interrupt's
	int distance;		// How much does god move any of the player. 
							// distance can be negetive or positive.
							// using this distance if any of players position is less than zero then bring him to start line.
							// If more than finish_distance then make him win.
							// If time is after completion of game than you can ignore it as we will already have winner.
};

struct race {
	
	//	Don't change these variables.
	//	speeds are unit distance per unit time.
	int printing_delay;
	int tortoise_speed;					// speed of Turtle
	int hare_speed;						// speed of hare
	int hare_sleep_time; 				// how much time does hare sleep (in case he decides to sleep)
	int hare_turtle_distance_for_sleep; // minimum lead which hare has on turtle after which hare decides to move
										// Any lead greater than this distance and hare will ignore turtle and go to sleep
	int finish_distance;				// Distance between start and finish line
	struct Repositioning* reposition;	// pointer to array containing Randomizer's decision
	int repositioning_count;			// number of elements in array of repositioning structure
	
	//	Add your custom variables here.
	int timeUnit;
	int turtle_dist;
	int hare_dist;
	int turtle_prev_dist;
	struct barrier_t  barrier_time;
	struct barrier_t  barrier_loop;
	int winner_decided;
	pthread_mutex_t winner_lock;
	pthread_mutex_t haredone_t;
	int hareDone;
	pthread_cond_t hareDoneCond;
};


void* Turtle(void *race);
void* Hare(void *race);
void* Randomizer(void *race);
void* Report(void *race);

char init(struct race *race)
{
	pthread_cond_init(&race->hareDoneCond,NULL);
	pthread_mutex_init(&race->haredone_t,NULL);
	//initializing shared data ,lock and barrier
	pthread_mutex_init(&(race->winner_lock),NULL);
	 barrier_init(&(race->barrier_loop),5);
	barrier_init(&(race->barrier_time),5);
	race->winner_decided=0;
	race->turtle_prev_dist=0;
	race->timeUnit=-1;
	race->hare_dist=0;
	race->turtle_dist=0;
	race->hareDone=0;
char win='-';
	//creation of threads
	pthread_t threads[4];
	pthread_create(&threads[0],NULL,Turtle,(void *)race);
	pthread_create(&threads[1],NULL,Hare,(void *)race);
	pthread_create(&threads[2],NULL,Randomizer,(void *)race);
	pthread_create(&threads[3],NULL,Report,(void *)race);	
//	int loop=0;
	int winner=0;
	while(1){
		pthread_mutex_lock(&(race->winner_lock));
			if(race->turtle_dist>=race->finish_distance ){
				race->winner_decided=1;
				win='T';
			}
			else if(race->hare_dist>=race->finish_distance ){
					race->winner_decided=1;
					win='T';
			}
			winner=race->winner_decided;
		pthread_mutex_unlock(&(race->winner_lock));
		if(winner){

			//printf("winner decided \n");
			break;
		}

		race->timeUnit++;
		race->hareDone=0;
	//	printf("init generating  time \n");
		barrier_wait(&(race->barrier_time));


	//	printf("init waiting for loop \n");
		barrier_wait(&(race->barrier_loop));


	//	loop++;

	}



	pthread_join(threads[0],NULL);
	pthread_join(threads[1],NULL);
	pthread_join(threads[2],NULL);
	pthread_join(threads[3],NULL);
	return win; 
}

void* Turtle(void *arg)
{	struct race *race=(struct race*)arg;

	//int loop=0;
	int winner=0;
	while(1){
		pthread_mutex_lock(&(race->winner_lock));
		if(race->turtle_dist>=race->finish_distance ){
				winner=1;
			}
		else if(race->hare_dist>=race->finish_distance ){
			winner=1;
			}
		//winner=race->winner_decided;
		pthread_mutex_unlock(&(race->winner_lock));
		if(winner){
			break;
		}
		
		race->turtle_prev_dist=race->turtle_dist;
		barrier_wait(&(race->barrier_time));
	//	printf("turtle waiting for time \n");
		pthread_mutex_lock(&race->haredone_t);
			while(race->hareDone!=1)
				pthread_cond_wait(&race->hareDoneCond,&race->haredone_t);
		pthread_mutex_unlock(&race->haredone_t);
		race->turtle_dist+= race->tortoise_speed;
		printf("turtle waiting for loop \n");
		barrier_wait(&(race->barrier_loop));


	//	loop++;https://www.enterprisedb.com/edb-docs/d/edb-postgres-enterprise-manager/reference/online-documentation/7.8/pem_interpreting_graphical_query.html

	}
	return NULL;
}

void* Hare(void *arg)
{
struct race *race=(struct race*)arg;
	//int loop=0;
	int winner=0;
	int sleep_remain;
	while(1){
		pthread_mutex_lock(&(race->winner_lock));
			if(race->turtle_dist>=race->finish_distance ){
			winner=1;
			}
		else if(race->hare_dist>=race->finish_distance ){
				winner=1;
			}
			//winner=race->winner_decided;
		pthread_mutex_unlock(&(race->winner_lock));
		if(winner){
			break;
		}

	//	printf("hare waiting for time \n");
		barrier_wait(&(race->barrier_time));
		if(sleep_remain>0){
			sleep_remain--;
	//		printf("hare sleeping");
		}else
		{	
			//runs and this iteration also reduce sleeping time
			if((race->turtle_prev_dist - race->turtle_dist ) >= race->hare_turtle_distance_for_sleep){
				//handles if sleep time is zero
				if(race->hare_sleep_time==0){
					race->hare_dist+=race->hare_speed;
	//				printf("hare runs because sleep zero\n");
				}
				sleep_remain=race->hare_sleep_time-1;
			}else
			{
				//runs and then sleep
	//			printf("hare runs \n and now going to sleep");
				race->hare_dist+=race->hare_speed;
				sleep_remain=race->hare_sleep_time;
			}
		
		}
		pthread_mutex_lock(&race->haredone_t);
		race->hareDone=1;
		
		pthread_mutex_unlock(&race->haredone_t);
		pthread_cond_signal(&race->hareDoneCond);
		//printf("hare waiting for loop \n");
		barrier_wait(&(race->barrier_loop));


	//	loop++;

	}


	return NULL;
}


void* Randomizer(void *arg)
{
struct race *race=(struct race*)arg;
	int rep_count=0;
	//int loop=0;
	int winner=0;
	while(1){
		pthread_mutex_lock(&(race->winner_lock));
			if(race->turtle_dist>=race->finish_distance ){
				winner=1;
			}
		else if(race->hare_dist>=race->finish_distance ){
			winner=1;
			}
			//winner=race->winner_decided;
		pthread_mutex_unlock(&(race->winner_lock));
		if(winner){
			break;
		}

	//	printf("rand waiting for time \n");
		barrier_wait(&(race->barrier_time));
		if(race->repositioning_count>rep_count){
	//		printf("time to randomize %d\n",race->reposition[rep_count].time);
			if(race->timeUnit == race->reposition[rep_count].time){
	//			printf("repostining %d current timeunit %d \n",race->reposition[rep_count].time,race->timeUnit);
				if(race->reposition[rep_count].player=='T'){
					race->turtle_dist+=race->reposition[rep_count].distance;
				}else{
					race->hare_dist+=race->reposition[rep_count].distance;
				}
				rep_count++;
			}
			
		}
		

	//	printf("rand waiting for loop \n");
		barrier_wait(&(race->barrier_loop));


		//loop++;

	}

	return NULL;
}

void* Report(void *arg)
{
struct race *race=(struct race*)arg;

//int loop=0;
	int winner=0;
	while(1){
		pthread_mutex_lock(&(race->winner_lock));
		if(race->turtle_dist>=race->finish_distance ){
			winner=1;
			}
		else if(race->hare_dist>=race->finish_distance ){
		winner=1;
			}
			//winner=race->winner_decided;
		pthread_mutex_unlock(&(race->winner_lock));
		if(winner){
			break;
		}

	//	printf("report waiting for time \n");
		barrier_wait(&(race->barrier_time));

		if((race->timeUnit % race->printing_delay)==0)
			printf("Hare distance %d and turtle distance %d at time unit %d\n",race->hare_dist,race->turtle_dist,race->timeUnit);


//		printf("report waiting for loop \n");
		barrier_wait(&(race->barrier_loop));


		//loop++;

	}

	return NULL;
}

